unit sfman;

interface

Uses Windows;

Const
     SFERR_BASE_INVALID             =100;
     SFERR_BASE_CONTENTION          =200;
     SFERR_BASE_API                 =400;
     SFERR_BASE_EXIT                =800;
     SFERR_BASE_UNDEFINE            =900;

{
--------------------------------
      General Error Messages
--------------------------------
}

     SFERR_NOERR                     = 0;
     SFERR_UNDEFINE_ERROR            =(SFERR_BASE_UNDEFINE+1);

{
--------------------------------
   API Error Messages
--------------------------------
}

     SFERR_LOAD_DLL_FAIL            =(SFERR_BASE_API+1);
     SFERR_GET_ENTRYPOINT_FAIL      =(SFERR_BASE_API+2);
     SFERR_DEVICE_NOT_FOUND         =(SFERR_BASE_API+3);
     SFERR_INTERFACE_NOT_SUPPORTED  =(SFERR_BASE_API+4);
     SFERR_LAST_API                 =(SFERR_BASE_API+5);

{
--------------------------------
   Invalid Error Messages
--------------------------------
}

     SFERR_SYNTH_INVALID            =(SFERR_BASE_INVALID+5);
     SFERR_BANK_INDEX_INVALID       =(SFERR_BASE_INVALID+6);
     SFERR_PATHNAME_INVALID         =(SFERR_BASE_INVALID+7);
     SFERR_FORMAT_INVALID           =(SFERR_BASE_INVALID+8);
     SFERR_PRESET_INDEX_INVALID     =(SFERR_BASE_INVALID+9);
     SFERR_ACCESS_NOT_PERMITTED     =(SFERR_BASE_INVALID+11);
     SFERR_VERSION_INVALID          =(SFERR_BASE_INVALID+12);
     SFERR_DEVICE_INVALID           =(SFERR_BASE_INVALID+13);
     SFERR_SUPPORT_INVALID          =(SFERR_BASE_INVALID+14);
     SFERR_INVALID_SOUND_ROM        =(SFERR_BASE_INVALID+15);
     SFERR_NOT_STATIC_MEMORY        =(SFERR_BASE_INVALID+16);
     SFERR_LAST_INVALID             =(SFERR_BASE_INVALID+17);

{
--------------------------------
   Contention Error Messages
--------------------------------
}

     SFERR_DLL_BUSY                 =(SFERR_BASE_CONTENTION+1);
     SFERR_DEVICE_BUSY              =(SFERR_BASE_CONTENTION+2);
     SFERR_RESOURCE_INSUFFICIENT    =(SFERR_BASE_CONTENTION+3);
     SFERR_SYSMEM_INSUFFICIENT      =(SFERR_BASE_CONTENTION+4);
     SFERR_SOUNDMEM_INSUFFICIENT    =(SFERR_BASE_CONTENTION+5);
     SFERR_LAST_CONTENTION          =(SFERR_BASE_CONTENTION+6);

Type
    INTERFACEID = DWORD; //since Delphi doesn't have proper enums

Const
    ID_SFMANL100API = $00010000;
    ID_SFMANL101API = $00010001;

Type
    SFBANKSTYLE = WORD;
Const
    SFBANK_AWE32 = 0;
    SFBANK_CC0_ONLY = SFBANK_AWE32;
    SFBANK_GS = SFBANK_AWE32;
    SFBANK_DEFAULT = SFBANK_AWE32;
    SFBANK_MMA = 1;
    SFBANK_CC0_CC32 = SFBANK_MMA;
Type
    PSFBANKSTYLE = ^SFBANKSTYLE;
    SFFLAG_OPERATION = (SFFLAG_OPER_FILE, SFFLAG_OPER_MEMORY);
    SFMANCAPS = DWORD;
Const
    SFMANCAP_DYNAMIC_MEM_CAP = $80000000;
    SFMANCAP_SOFTWARE_SYNTH_CAP = $40000000;
    SFMANCAP_NONMMSYSTEM_COMPATIBLE_CAP = $20000000;
    SFMANCAP_NONWAVEFORM_SUPPORT_CAP = $10000000;
Type
    CSFMIDILocation = packed record
                    m_BankIndex,m_PresetIndex: Word;
    end;
    SFMIDILOCATION = CSFMIDILocation;
    PSFMIDILOCATION = ^SFMIDILOCATION;
    CSFBufferObject = packed record
                    m_Size:  DWORD;
                    m_Buffer:Pointer;
                    m_SizeUsed:DWORD;
                    m_Flag:  Word;
    end;
    PSFBUFFEROBJECT = ^CSFBufferObject;
    CSFCapsObject = packed record
                  m_SizeOf:      Word;
                  m_RouterID,m_DevCaps,m_MoreDevCaps,m_RomID,m_RomVer: DWORD;
                  m_DevName:     Array[0..39] of Char;
                  m_DevMgrName,m_DevMgrEntry: Array[0..19] of Char;
    end;
    PSFCAPSOBJECT = ^CSFCapsObject;
Const
     SF_MASTER_MANAGER_FILENAME = 'SFMAN32.DLL';
     SF_FUNCTION_TABLE_NAME = 'SFManager';
//function: SFMAN_GET_ROUTING_INDEX
     SFMAN_PERCUSSIVE_BANK = $8000;
Type
    SFDEVINDEX = WORD;
    SFMANAGERQI = function(IID:INTERFACEID;PDW:PDWORD):LRESULT; cdecl;
//    PSFMANAGERQI = ^SFMANAGERQI;
    SFMANAGER = packed record
              SF_QueryInterface: SFMANAGERQI;
    end;
    PSFMANAGER = ^SFMANAGER;
//    SFMANL101TAG = record
    sfGetNumDevsFunc = function(Value:PDWORD):LRESULT; cdecl;
    sfGetDevCapsFunc = function(Val1:SFDEVINDEX;Val2:PSFCAPSOBJECT):LRESULT; cdecl;
    sfFillPDWFunc = function(Val1:SFDEVINDEX;Val2:PDWORD):LRESULT; cdecl;
    sfFunc = function(Value:SFDEVINDEX):LRESULT; cdecl;
    sfQuerySSMSFunc = function(Val1:SFDEVINDEX;Val2,Val3:PDWORD):LRESULT; cdecl;
    sfFillBufFunc = function(Val1:SFDEVINDEX;Val2:PSFBUFFEROBJECT):LRESULT; cdecl;
    sfSelSynthFunc = function(Val1:SFDEVINDEX;Val2:Word):LRESULT; cdecl;
    sfBankFunc = function(Val1:SFDEVINDEX;Val2:PSFMIDILOCATION;Val3:PSFBUFFEROBJECT):LRESULT; cdecl;
    sfClearFunc = function(Val1:SFDEVINDEX;Val2:PSFMIDILOCATION):LRESULT; cdecl;
    sfPresetFunc = function(Val1:SFDEVINDEX;Val2,Val3:PSFMIDILOCATION;Val4:PSFBUFFEROBJECT):LRESULT; cdecl;
    sfDevMsgFunc = function(Val1:SFDEVINDEX;Val2:UINT;Val3,Val4:LPARAM):LRESULT; cdecl;

    SFMANL101API = record
                 SF_GetNumDevs:    sfGetNumDevsFunc;
                 SF_GetDevCaps:    sfGetDevCapsFunc;
                 SF_GetRouterID:   sfFillPDWFunc;
                 SF_IsDeviceFree:  sfFunc;
                 SF_Open:          sfFunc;
                 SF_Close:         sfFunc;
                 SF_IsMidiBankUsed:sfFillPDWFunc;
                 SF_QueryStaticSampleMemorySize: sfQuerySSMSFunc;
                 SF_GetAllSynthEmulations:       sfFillBufFunc;
                 SF_GetSynthEmulation:           sfFillBufFunc;
                 SF_SelectSynthEmulation:        sfSelSynthFunc;
                 SF_LoadBank:                    sfBankFunc;
                 SF_GetLoadedBankDescriptor:     sfBankFunc;
                 SF_GetLoadedBankPathname:       sfBankFunc;
                 SF_ClearLoadedBank:             sfClearFunc;
                 SF_LoadPreset:                  sfPresetFunc;
                 SF_GetLoadedPresetDescriptor:   sfBankFunc;
                 SF_LoadWaveform:                sfBankFunc;
                 SF_ClearLoadedWaveform:         sfClearFunc;
                 SF_DeviceSpecificMessage:       sfDevMsgFunc;
    end;
    PSFMANL101API = ^SFMANL101API;



procedure SFMAN_GET_ROUTING_INDEX(dwID:DWORD;var B1,B2,B3,B4: Byte);

implementation

procedure SFMAN_GET_ROUTING_INDEX(dwID:DWORD;var B1,B2,B3,B4: Byte);
begin
B1 := dwID and $FF;
B2 := (dwID shr 8) and $FF;
B3 := (dwID shr 16) and $FF;
B4 := (dwID shr 24) and $FF;
end;

end.
